Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/export/shape/service/ExportShapeParametersImpl.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/export/shape/service/ExportShapeParametersImpl.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/export/shape/service/ExportShapeParametersImpl.java	(revision 44395)
@@ -25,7 +25,7 @@
         AttributeNamesTranslator attr = new CutAttributeNamesTranslator(ExportDBFService.MAX_FIELD_NAME_LENGTH);
         this.exportAttributes.setNamesTranslator(attr);
     }
-    
+
     @Override
     public String getServiceName() {
         return ExportShapeServiceFactory.SERVICE_NAME;
@@ -56,6 +56,7 @@
         return this.useSimplifiedExport;
     }
 
+    @Override
     public void setUseSimplifiedExport(boolean useSimplifiedExport) {
         this.useSimplifiedExport = useSimplifiedExport;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/export/jdbc/service/ExportJDBCParametersImpl.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/export/jdbc/service/ExportJDBCParametersImpl.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/export/jdbc/service/ExportJDBCParametersImpl.java	(revision 44395)
@@ -41,6 +41,13 @@
     public ExportJDBCParametersImpl(ExportJDBCServiceFactory factory) {
         super(factory);
         this.exportAttributes.setNamesTranslator(new ExportJDBCAttributeNamesTranslator(this));
+        
+        this.canCreatetable = true;
+        this.translateIdentifiersToLowerCase = true;
+        this.removeSpacesInIdentifiers = true;
+        this.translateHyphens = true;
+        this.createIndexInGeometryRow = true;
+        this.updateTableStatistics = true;
     }
 
     @Override
@@ -387,8 +394,8 @@
 
     public ExportJDBCParameters clone() throws CloneNotSupportedException {
         ExportJDBCParameters clone = (ExportJDBCParameters) super.clone();
+        clone.setExplorerParameters((JDBCServerExplorerParameters) this.explorerParameters.getCopy());
         clone.getExportAttributes().setNamesTranslator(new ExportJDBCAttributeNamesTranslator(clone));
-//        clone.setExplorerParameters(this.explorerParameters.clone());
         return clone;
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.api/src/main/java/org/gvsig/export/swing/spi/ExportPanelsManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.api/src/main/java/org/gvsig/export/swing/spi/ExportPanelsManager.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.api/src/main/java/org/gvsig/export/swing/spi/ExportPanelsManager.java	(revision 44395)
@@ -10,6 +10,7 @@
 public interface ExportPanelsManager {
 
     public static final String PANEL_CHECK_GEOMETRIES = "PANEL_CHECK_GEOMETRIES";
+    public static final String PANEL_SELECT_CHARSET = "PANEL_SELECT_CHARSET";
     public static final String PANEL_SELECT_FILTER = "PANEL_SELECT_EXPORT_FILTER";
     public static final String PANEL_SELECT_GEOMETRY_TYPE = "PANEL_SELECT_GEOMETRY_TYPE";
     public static final String PANEL_SELECT_OUTPUT_FILE = "PANEL_SELECT_OUTPUT_FILE";
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportAttributes.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportAttributes.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportAttributes.java	(revision 44395)
@@ -20,6 +20,10 @@
 
     public ExportAttributes clone() throws CloneNotSupportedException;
 
+    public void setActive(boolean b);
+    
+    public boolean isActive();
+
     public interface ExportAttribute extends Cloneable {
 
         public FeatureAttributeDescriptor getDescriptor();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportService.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportService.java	(revision 44395)
@@ -110,7 +110,6 @@
 //        }
 //        return this.attributeNamesTranslator;
 //    }
-
     @Override
     public List<OpenDataStoreParameters> getTargetOpenStoreParameters() throws ExportException {
         List<OpenDataStoreParameters> r = new ArrayList<>();
@@ -151,7 +150,12 @@
             dataManager.newStore(explorerName, providerName, newStoreParameters, true);
             target = (FeatureStore) dataManager.openStore(providerName, openStoreParameters);
 
-            FeatureType theTargetFeatureType = this.getParameters().getExportAttributes().getTargetFeatureType();//target.getDefaultFeatureType();
+            FeatureType theTargetFeatureType;
+            if (this.getParameters().getExportAttributes().isActive()) {
+                theTargetFeatureType = this.getParameters().getExportAttributes().getTargetFeatureType();
+            } else {
+                theTargetFeatureType = target.getDefaultFeatureType();
+            }
             FeatureType theSourceFeatureType = featureSet.getDefaultFeatureType();
 
             ExportGeometryHelper geomHelper = null;
@@ -170,7 +174,7 @@
             target.edit(FeatureStore.MODE_APPEND);
             it = featureSet.fastIterator();
 
-            long featureCount = 0;
+            long featureCount = 1;
             while (it.hasNext()) {
                 this.getTaskStatus().setCurValue(featureCount);
 
@@ -214,21 +218,29 @@
     protected void copyValues(Feature source, EditableFeature target) {
         FeatureType sourceType = source.getType();
         FeatureType targetType = target.getType();
+        ExportAttributes exp = this.getParameters().getExportAttributes();
+        boolean isActive = exp.isActive();
         for (FeatureAttributeDescriptor targetAttr : targetType) {
             if (targetAttr.isReadOnly() || targetAttr.isComputed()) {
                 continue;
             }
             String targetAttrName = targetAttr.getName();
             //translate field
-            String sourceAttrName = getParameters().getExportAttributes().getSourceName(targetAttrName);
-            ExportAttributes exp = this.getParameters().getExportAttributes();
-            for (ExportAttributes.ExportAttribute exportAttribute : exp) {
-                if (StringUtils.equals(exportAttribute.getNewName(),targetAttrName)) {
-                    sourceAttrName = exportAttribute.getName();
+            FeatureAttributeDescriptor sourceAttr;
+            String sourceAttrName;
+            if (isActive) {
+                sourceAttrName = exp.getSourceName(targetAttrName);
+                for (ExportAttributes.ExportAttribute exportAttribute : exp) {
+                    if (StringUtils.equals(exportAttribute.getNewName(), targetAttrName)) {
+                        sourceAttrName = exportAttribute.getName();
+                    }
                 }
+
+                sourceAttr = sourceType.getAttributeDescriptor(sourceAttrName);
+            } else {
+                sourceAttrName = targetAttrName;
+                sourceAttr = sourceType.getAttributeDescriptor(targetAttrName);
             }
-
-            FeatureAttributeDescriptor sourceAttr = sourceType.getAttributeDescriptor(sourceAttrName);
             if (sourceAttr != null) {
                 Object value = source.get(sourceAttrName);
                 if (value == null) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportParameters.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/spi/AbstractExportParameters.java	(revision 44395)
@@ -3,7 +3,6 @@
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Date;
-import org.apache.commons.lang3.StringUtils;
 import org.gvsig.export.ExportAttributes;
 import org.gvsig.export.ExportLocator;
 import org.gvsig.fmap.dal.exception.DataException;
@@ -109,7 +108,6 @@
     @Override
     public ExportParameters clone() throws CloneNotSupportedException {
         ExportParameters clone = (ExportParameters) super.clone();
-        clone.setContext(new Date());
 
         if (this.filterExpression != null) {
             clone.setFilterExpresion(this.filterExpression.clone());
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportCharsetParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportCharsetParameters.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.api/src/main/java/org/gvsig/export/ExportCharsetParameters.java	(revision 44395)
@@ -0,0 +1,9 @@
+package org.gvsig.export;
+
+public interface ExportCharsetParameters {
+
+    public void setCharset(String charset);
+    
+    public String getCharset();
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/DefaultExportProcess.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/DefaultExportProcess.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/DefaultExportProcess.java	(revision 44395)
@@ -1,16 +1,13 @@
 package org.gvsig.export.impl;
 
 import java.util.List;
-import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.ICoordTrans;
 import org.cresques.cts.IProjection;
-import org.gvsig.export.ExportAttributes;
 import org.gvsig.export.ExportException;
 import org.gvsig.export.ExportLocator;
 import org.gvsig.export.ExportParameters;
 import org.gvsig.export.ExportParametersGeometry;
 import org.gvsig.export.ExportProcess;
-import org.gvsig.export.spi.AttributeNamesTranslator;
 import org.gvsig.export.spi.ExportService;
 import org.gvsig.export.spi.ExportServiceFactory;
 import org.gvsig.export.spi.ExportServiceManager;
@@ -46,10 +43,7 @@
 
     @Override
     public void setOutputFormat(String serviceName) throws ExportException {
-        
-        if (this.factory != null && StringUtils.equalsIgnoreCase(serviceName, this.factory.getName())) {
-            return;
-        }
+
         ExportServiceManager serviceManager = ExportLocator.getServiceManager();
         this.factory = serviceManager.getServiceFactory(serviceName);
         this.parameters = this.factory.createParameters();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/service/DefaultExportAttributes.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/service/DefaultExportAttributes.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/export/impl/service/DefaultExportAttributes.java	(revision 44395)
@@ -8,19 +8,14 @@
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
-import java.util.logging.Level;
-import org.apache.commons.collections.ListUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.export.ExportAttributes;
-import org.gvsig.export.ExportLocator;
 import org.gvsig.export.spi.AttributeNamesTranslator;
 import org.gvsig.export.spi.DummyAttributeNamesTranslator;
 import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
-import org.gvsig.tools.dataTypes.DataType;
-import org.gvsig.tools.util.UnmodifiableBasicListAdapter;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -30,10 +25,12 @@
     private AttributeNamesTranslator namesTranslator = null;
     private FeatureType sourceFeatureType;
     static final Logger LOGGER = LoggerFactory.getLogger(DefaultExportAttributes.class);
+    private boolean active;
 
     public DefaultExportAttributes() { //FeatureType ftype) {
 //        this.setSourceFeatureType(ftype);
         this.namesTranslator = new DummyAttributeNamesTranslator();
+        this.active = false;
     }
 
     public void fillExportAttributes(FeatureType ftype) {
@@ -257,4 +254,16 @@
     public void setExportAttributes(List<ExportAttribute> exportAttributes) {
         this.exportAttributes = exportAttributes;
     }
+
+    @Override
+    public void setActive(boolean active) {
+        this.active = active;
+    }
+
+    @Override
+    public boolean isActive() {
+        return this.active;
+    }
+    
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFilesystemServerProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFilesystemServerProvider.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFilesystemServerProvider.java	(revision 44395)
@@ -160,7 +160,7 @@
 
                     CSVNewStoreParameters newparams = (CSVNewStoreParameters) params;
                     CsvPreference defaultPreference = CSVStoreParameters.getPredefinedCSVPreferences(newparams);
-
+                    
                     s = CSVStoreParameters.getQuoteCharacter(params);
                     if (StringUtils.isBlank(s)) {
                         quoteChar = (char) defaultPreference.getQuoteChar();
@@ -188,15 +188,17 @@
                         builder.skipComments(cs);
                     }
 
-                    builder.surroundingSpacesNeedQuotes(CSVStoreParameters
-                            .getSurroundingSpacesNeedQuotes(newparams));
+                    //builder.surroundingSpacesNeedQuotes(CSVStoreParameters
+                    //        .getSurroundingSpacesNeedQuotes(newparams));
+                    builder.surroundingSpacesNeedQuotes(true);
+                    
                     QuoteMode quoteMode = CSVStoreParameters.getQuoteMode(newparams);
                     if (quoteMode != null) {
                         builder.useQuoteMode(quoteMode);
                     }
 
                     CsvPreference csvpreferences = builder.build();
-
+                    
                     writer.initialize(params, file.getAbsoluteFile(), params.getDefaultFeatureType(), csvpreferences);
                     writer.begin();
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFeatureWriter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFeatureWriter.java	(revision 44394)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.csv/src/main/java/org/gvsig/fmap/dal/store/csv/CSVFeatureWriter.java	(revision 44395)
@@ -6,11 +6,13 @@
 package org.gvsig.fmap.dal.store.csv;
 
 import java.io.File;
+import java.io.FileOutputStream;
 import java.io.FileWriter;
 import java.io.IOException;
+import java.io.OutputStreamWriter;
+import java.io.Writer;
 import java.util.Locale;
 import org.gvsig.fmap.dal.DataTypes;
-import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.exception.PerformEditingException;
@@ -35,7 +37,7 @@
     private boolean calculate_envelope = false;
     private CsvListWriter listWriter = null;
     private CsvPreference csvpreferences = null;
-    private FileWriter fwriter = null;
+    private Writer writer = null;
     private FeatureType ftype;
     private File file;
     private String[] values;
@@ -46,6 +48,7 @@
     private Locale locale = null;
     private CSVStoreParameters storeParameters;
     private static final Logger logger = LoggerFactory.getLogger(CSVFeatureWriter.class);
+    private String charset = null;
 
     public void initialize(CSVStoreParameters storeParameters, File file, FeatureType ftype, CsvPreference csvpreferences) {
         this.file = file;
@@ -66,12 +69,18 @@
         }
         this.convert = ToolsLocator.getDataTypesManager().getCoercion(org.gvsig.tools.dataTypes.DataTypes.STRING);
         this.errorcounts = 0;
+        this.charset = CSVStoreParameters.getCharset(storeParameters);
     }
 
     public void beginAppend() {
         try {
-            this.fwriter = new FileWriter(file, true);
-            this.listWriter = new CsvListWriter(this.fwriter, this.csvpreferences);
+            FileOutputStream fos = new FileOutputStream(file, true);
+            if (this.charset != null) {
+                this.writer = new OutputStreamWriter(fos, this.charset);
+            } else {
+                this.writer = new OutputStreamWriter(fos);
+            }
+            this.listWriter = new CsvListWriter(this.writer, this.csvpreferences);
             if (ftype != null) {
                 this.descriptors = ftype.getAttributeDescriptors();
                 int n = 0;
@@ -91,12 +100,12 @@
 
     public void begin() {
         try {
-            this.fwriter = new FileWriter(file);
+            this.writer = new FileWriter(file);
         } catch (IOException e) {
             logger.warn("Can't open file for write (" + file.getAbsolutePath() + ").", e);
             throw new RuntimeException(e);
         }
-        this.listWriter = new CsvListWriter(this.fwriter, this.csvpreferences);
+        this.listWriter = new CsvListWriter(this.writer, this.csvpreferences);
         int n = 0;
         for (FeatureAttributeDescriptor descriptor : descriptors) {
             if (descriptor.getEvaluator() == null) {
@@ -195,13 +204,13 @@
             }
             listWriter = null;
         }
-        if (fwriter != null) {
+        if (writer != null) {
             try {
-                fwriter.close();
+                writer.close();
             } catch (Exception ex) {
                 // Ignore error
             }
-            fwriter = null;
+            writer = null;
         }
     }
 
